/*****************************************************************************
 *                DigCC: a minimal C compiler for DigMIPS                    *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2012 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __BIT_VECTOR_H
#define __BIT_VECTOR_H

#include <iostream>
#include <vector>

using namespace std;

class BitVector
{
 public:
  int size;
  vector<int> bit_set;

  BitVector(int size);

  void insert(int e);
  void insert(vector<int> e);

  void remove(int e);

  int is_empty();

  int has(int e); //belonging test

  int operator ==(BitVector& b);

  vector<int> to_vector();

  string to_string_dot(); //For .dot output

  BitVector* clone();
};

BitVector& operator |(BitVector& b1, BitVector& b2); //union
BitVector& operator &(BitVector& b1, BitVector& b2); //intersection
BitVector& operator -(BitVector& b1, BitVector& b2); //difference

//pretty-printer
ostream& operator <<(ostream& sout, BitVector& b);

#endif
