/*****************************************************************************
 *                DigCC: a minimal C compiler for DigMIPS                    *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2012 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __DAG_H
#define __DAG_H

#include "PseudoCode.h" 
#include "BasicBlock.h" 

#include <iostream>  //For the pretty-printer

#include <vector>
#include <set>
#include <map>

using namespace std;

class Dag
{
 public:
  vector<PseudoCode*> node;
  vector<vector<int> > succ;
  set<int> roots; //nodes w/o predecessors
  map<int,PseudoCode*> node_reg; //last node defining register 'reg'
  map<PseudoCode*,vector<int> > node_def; //registers (lastly) defined by a node

  map<int,PseudoCode*> def;

  Dag(BasicBlock* basic_block);

  void simplify(BitVector* live_out);

  void print_dot(ostream& sout);
  void show_dot();

 private:
  void simplify_rec(int node_rank);
};

#endif
